﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.9
@EndOfDesignText@
Sub Class_Globals
	Public STR_SEP As String = ","
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	DownloadSubCats1
End Sub

Sub DownloadSubCats1
	Wait For (GetSubCatsNIDs (0, "", "")) Complete (SubCatsNIDs1 As List)
	Dim NumbersFromJSON As List = SubCatsNIDs1
	
	Log ("THE CORRECT RESULT SHOULD BE: 18 19 22 24 93 106 108 123 126 128 132 149 155 171 (14 NUMBERS)")
	For i=0 To NumbersFromJSON.Size-1
		Log (NumbersFromJSON.Get (i))
	Next

End Sub

Sub GetSubCatsNIDs (nid As Int, aUser As String, aPsw As String) As ResumableSub
	
	Try
		Dim parser As JSONParser
		parser.Initialize(File.ReadString(File.DirAssets, "json_file.json"))
		Dim JRoot As Map = parser.NextObject
		
		'the final purpose is to obtain a list of numbers contained within the json file attached in the "field_list_nodi_categorie" field.
		'numbers within field "field_list_nodi_categorie" has CRLF attached on the left
		'STR_SEP = ","
		
		Dim field_elenco_nodi_categorie As List = JRoot.Get("field_elenco_nodi_categorie")
		Dim value As String = field_elenco_nodi_categorie.Get(0)
		Dim nids As String = value.Replace(CRLF, STR_SEP)
		
'		Log ("GetSubCatsNIDs | value: " & value)
'		Log ("GetSubCatsNIDs | nids: " & nids)
		
		Private arrNIDs() As String
		arrNIDs = Regex.Split(STR_SEP, nids)
		Private lstNIDs As List
		lstNIDs.Initialize
		For i=0 To arrNIDs.Length-1
			Private strNID As String = arrNIDs(i)
			lstNIDs.Add(GetNumFromStr(strNID))
		Next
	Catch
		'string input is not valid
		Log ("API ERROR (GetSubCatsNIDs) - " & LastException.Message)
		Private lstNIDs As List
		lstNIDs.Initialize 'return an empty list
	End Try

	Return lstNIDs
End Sub

Sub GetNumFromStr(aStr As String) As Int
	Dim m As Matcher = Regex.Matcher("\d+", aStr)
	If m.Find Then
		Dim number As Int = m.Match
		'Log(number)
	End If
	Return number
End Sub